// it doesn't work with wordwrap on, so turn it off if needed
    if (Document.Wordwrap) {
      Document.Wordwrap = false;
    }
    // find cursor position
    var x = Document.CursorX;
    var y = Document.CursorY;
    if (x>0) {
        //x = x+1;
        // read line with cursor
        var text = Document.Lines(y);
        // find quotes on the left
        var roundB_L = ScriptUtils.WRightPosFrom("(", text, x);
        var squareB_L = ScriptUtils.WRightPosFrom("[", text, x);
        var embrace_L = ScriptUtils.WRightPosFrom("{", text, x);
        if ((roundB_L==x)||(squareB_L==x)||(embrace_L==x)) {
           x++;
        }
        // message debug
        var roundB_Lstr = VarToStr(roundB_L);
        var squareB_Lstr = VarToStr(squareB_L);
        var embrace_Lstr= VarToStr(embrace_L);
        var xpos = VarToStr(x);
        //ShowMessage("xpos : " + xpos + "\nroundB_L : " + roundB_Lstr + "\nsquareB_L : " + squareB_Lstr + "\nembrace_L : " + embrace_Lstr);
        // calculate which left boundary is closer to the caret
        if (roundB_L >= 0) {
           var roundB = x-roundB_L
        }
        if (squareB_L >= 0) {
           var squareB = x-squareB_L
        }
        if (embrace_L >= 0) {
           var embrace = x-embrace_L
        }
        if ((roundB > 0)||(squareB > 0)||(embrace > 0)) {
            // message debug
            roundB_Lstr = VarToStr(roundB);
            squareB_Lstr = VarToStr(squareB);
            embrace_Lstr= VarToStr(embrace);
            //ShowMessage("the lower is better\n\nxpos : " + xpos + "\nroundB : " + roundB_Lstr + "\nsquareB : " + squareB_Lstr + "\nembrace : " + embrace_Lstr);

            if ((roundB < squareB)&&(roundB < embrace)) {
                // find roundB quote on the right on the right
                var boundary_R = ScriptUtils.WPosFrom(")", text, x);
                var qL = roundB_L;
            }
            else if ((squareB < roundB)&&(squareB < embrace)) {
                // find squareB quote on the right on the right
                boundary_R = ScriptUtils.WPosFrom("]", text, x);
                qL = squareB_L;
            }
            else {
                // find squareB quote on the right on the right
                boundary_R = ScriptUtils.WPosFrom("}", text, x);
                qL = embrace_L;
            }
            // message debug
            var boundary_Rstr = VarToStr(boundary_R);
            //ShowMessage("boundary_Rstr : " + boundary_Rstr);
            // quit if boundry not found
            if (boundary_R == 0) {
              ShowMessage("Closing bracket can't be found on that line.");
            } else {
              // must be decreased to exclude rigt boundary from being copied
              boundary_R--;
              // select text inside boundaries
              Document.SetSelection(qL, y, boundary_R, y);
              // copy it to the clipboard
              Document.CopyToClipboard();
           }
        }
   }